git-rebase--interactive.shon commit Merge branch 'jc/diff-unique-abbrev-comments' into maint (0582a34)
   1# This shell script fragment is sourced by git-rebase to implement
   2# its interactive mode.  "git rebase --interactive" makes it easy
   3# to fix up commits in the middle of a series and rearrange commits.
   4#
   5# Copyright (c) 2006 Johannes E. Schindelin
   6#
   7# The original idea comes from Eric W. Biederman, in
   8# http://article.gmane.org/gmane.comp.version-control.git/22407
   9#
  10# The file containing rebase commands, comments, and empty lines.
  11# This file is created by "git rebase -i" then edited by the user.  As
  12# the lines are processed, they are removed from the front of this
  13# file and written to the tail of $done.
  14todo="$state_dir"/git-rebase-todo
  15
  16# The rebase command lines that have already been processed.  A line
  17# is moved here when it is first handled, before any associated user
  18# actions.
  19done="$state_dir"/done
  20
  21# The commit message that is planned to be used for any changes that
  22# need to be committed following a user interaction.
  23msg="$state_dir"/message
  24
  25# The file into which is accumulated the suggested commit message for
  26# squash/fixup commands.  When the first of a series of squash/fixups
  27# is seen, the file is created and the commit message from the
  28# previous commit and from the first squash/fixup commit are written
  29# to it.  The commit message for each subsequent squash/fixup commit
  30# is appended to the file as it is processed.
  31#
  32# The first line of the file is of the form
  33#     # This is a combination of $count commits.
  34# where $count is the number of commits whose messages have been
  35# written to the file so far (including the initial "pick" commit).
  36# Each time that a commit message is processed, this line is read and
  37# updated.  It is deleted just before the combined commit is made.
  38squash_msg="$state_dir"/message-squash
  39
  40# If the current series of squash/fixups has not yet included a squash
  41# command, then this file exists and holds the commit message of the
  42# original "pick" commit.  (If the series ends without a "squash"
  43# command, then this can be used as the commit message of the combined
  44# commit without opening the editor.)
  45fixup_msg="$state_dir"/message-fixup
  46
  47# $rewritten is the name of a directory containing files for each
  48# commit that is reachable by at least one merge base of $head and
  49# $upstream. They are not necessarily rewritten, but their children
  50# might be.  This ensures that commits on merged, but otherwise
  51# unrelated side branches are left alone. (Think "X" in the man page's
  52# example.)
  53rewritten="$state_dir"/rewritten
  54
  55dropped="$state_dir"/dropped
  56
  57end="$state_dir"/end
  58msgnum="$state_dir"/msgnum
  59
  60# A script to set the GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
  61# GIT_AUTHOR_DATE that will be used for the commit that is currently
  62# being rebased.
  63author_script="$state_dir"/author-script
  64
  65# When an "edit" rebase command is being processed, the SHA1 of the
  66# commit to be edited is recorded in this file.  When "git rebase
  67# --continue" is executed, if there are any staged changes then they
  68# will be amended to the HEAD commit, but only provided the HEAD
  69# commit is still the commit to be edited.  When any other rebase
  70# command is processed, this file is deleted.
  71amend="$state_dir"/amend
  72
  73# For the post-rewrite hook, we make a list of rewritten commits and
  74# their new sha1s.  The rewritten-pending list keeps the sha1s of
  75# commits that have been processed, but not committed yet,
  76# e.g. because they are waiting for a 'squash' command.
  77rewritten_list="$state_dir"/rewritten-list
  78rewritten_pending="$state_dir"/rewritten-pending
  79
  80# Work around Git for Windows' Bash whose "read" does not strip CRLF
  81# and leaves CR at the end instead.
  82cr=$(printf "\015")
  83
  84strategy_args=${strategy:+--strategy=$strategy}
  85test -n "$strategy_opts" &&
  86eval '
  87        for strategy_opt in '"$strategy_opts"'
  88        do
  89                strategy_args="$strategy_args -X$(git rev-parse --sq-quote "${strategy_opt#--}")"
  90        done
  91'
  92
  93GIT_CHERRY_PICK_HELP="$resolvemsg"
  94export GIT_CHERRY_PICK_HELP
  95
  96comment_char=$(git config --get core.commentchar 2>/dev/null | cut -c1)
  97: ${comment_char:=#}
  98
  99warn () {
 100        printf '%s\n' "$*" >&2
 101}
 102
 103# Output the commit message for the specified commit.
 104commit_message () {
 105        git cat-file commit "$1" | sed "1,/^$/d"
 106}
 107
 108orig_reflog_action="$GIT_REFLOG_ACTION"
 109
 110comment_for_reflog () {
 111        case "$orig_reflog_action" in
 112        ''|rebase*)
 113                GIT_REFLOG_ACTION="rebase -i ($1)"
 114                export GIT_REFLOG_ACTION
 115                ;;
 116        esac
 117}
 118
 119last_count=
 120mark_action_done () {
 121        sed -e 1q < "$todo" >> "$done"
 122        sed -e 1d < "$todo" >> "$todo".new
 123        mv -f "$todo".new "$todo"
 124        new_count=$(( $(git stripspace --strip-comments <"$done" | wc -l) ))
 125        echo $new_count >"$msgnum"
 126        total=$(($new_count + $(git stripspace --strip-comments <"$todo" | wc -l)))
 127        echo $total >"$end"
 128        if test "$last_count" != "$new_count"
 129        then
 130                last_count=$new_count
 131                eval_gettext "Rebasing (\$new_count/\$total)"; printf "\r"
 132                test -z "$verbose" || echo
 133        fi
 134}
 135
 136# Put the last action marked done at the beginning of the todo list
 137# again. If there has not been an action marked done yet, leave the list of
 138# items on the todo list unchanged.
 139reschedule_last_action () {
 140        tail -n 1 "$done" | cat - "$todo" >"$todo".new
 141        sed -e \$d <"$done" >"$done".new
 142        mv -f "$todo".new "$todo"
 143        mv -f "$done".new "$done"
 144}
 145
 146append_todo_help () {
 147        gettext "
 148Commands:
 149 p, pick = use commit
 150 r, reword = use commit, but edit the commit message
 151 e, edit = use commit, but stop for amending
 152 s, squash = use commit, but meld into previous commit
 153 f, fixup = like \"squash\", but discard this commit's log message
 154 x, exec = run command (the rest of the line) using shell
 155 d, drop = remove commit
 156
 157These lines can be re-ordered; they are executed from top to bottom.
 158" | git stripspace --comment-lines >>"$todo"
 159
 160        if test $(get_missing_commit_check_level) = error
 161        then
 162                gettext "
 163Do not remove any line. Use 'drop' explicitly to remove a commit.
 164" | git stripspace --comment-lines >>"$todo"
 165        else
 166                gettext "
 167If you remove a line here THAT COMMIT WILL BE LOST.
 168" | git stripspace --comment-lines >>"$todo"
 169        fi
 170}
 171
 172make_patch () {
 173        sha1_and_parents="$(git rev-list --parents -1 "$1")"
 174        case "$sha1_and_parents" in
 175        ?*' '?*' '?*)
 176                git diff --cc $sha1_and_parents
 177                ;;
 178        ?*' '?*)
 179                git diff-tree -p "$1^!"
 180                ;;
 181        *)
 182                echo "Root commit"
 183                ;;
 184        esac > "$state_dir"/patch
 185        test -f "$msg" ||
 186                commit_message "$1" > "$msg"
 187        test -f "$author_script" ||
 188                get_author_ident_from_commit "$1" > "$author_script"
 189}
 190
 191die_with_patch () {
 192        echo "$1" > "$state_dir"/stopped-sha
 193        make_patch "$1"
 194        die "$2"
 195}
 196
 197exit_with_patch () {
 198        echo "$1" > "$state_dir"/stopped-sha
 199        make_patch $1
 200        git rev-parse --verify HEAD > "$amend"
 201        gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
 202        warn "$(eval_gettext "\
 203You can amend the commit now, with
 204
 205        git commit --amend \$gpg_sign_opt_quoted
 206
 207Once you are satisfied with your changes, run
 208
 209        git rebase --continue")"
 210        warn
 211        exit $2
 212}
 213
 214die_abort () {
 215        apply_autostash
 216        rm -rf "$state_dir"
 217        die "$1"
 218}
 219
 220has_action () {
 221        test -n "$(git stripspace --strip-comments <"$1")"
 222}
 223
 224is_empty_commit() {
 225        tree=$(git rev-parse -q --verify "$1"^{tree} 2>/dev/null) || {
 226                sha1=$1
 227                die "$(eval_gettext "\$sha1: not a commit that can be picked")"
 228        }
 229        ptree=$(git rev-parse -q --verify "$1"^^{tree} 2>/dev/null) ||
 230                ptree=4b825dc642cb6eb9a060e54bf8d69288fbee4904
 231        test "$tree" = "$ptree"
 232}
 233
 234is_merge_commit()
 235{
 236        git rev-parse --verify --quiet "$1"^2 >/dev/null 2>&1
 237}
 238
 239# Run command with GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
 240# GIT_AUTHOR_DATE exported from the current environment.
 241do_with_author () {
 242        (
 243                export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
 244                "$@"
 245        )
 246}
 247
 248git_sequence_editor () {
 249        if test -z "$GIT_SEQUENCE_EDITOR"
 250        then
 251                GIT_SEQUENCE_EDITOR="$(git config sequence.editor)"
 252                if [ -z "$GIT_SEQUENCE_EDITOR" ]
 253                then
 254                        GIT_SEQUENCE_EDITOR="$(git var GIT_EDITOR)" || return $?
 255                fi
 256        fi
 257
 258        eval "$GIT_SEQUENCE_EDITOR" '"$@"'
 259}
 260
 261pick_one () {
 262        ff=--ff
 263
 264        case "$1" in -n) sha1=$2; ff= ;; *) sha1=$1 ;; esac
 265        case "$force_rebase" in '') ;; ?*) ff= ;; esac
 266        output git rev-parse --verify $sha1 || die "$(eval_gettext "Invalid commit name: \$sha1")"
 267
 268        if is_empty_commit "$sha1"
 269        then
 270                empty_args="--allow-empty"
 271        fi
 272
 273        test -d "$rewritten" &&
 274                pick_one_preserving_merges "$@" && return
 275        output eval git cherry-pick \
 276                        ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
 277                        "$strategy_args" $empty_args $ff "$@"
 278
 279        # If cherry-pick dies it leaves the to-be-picked commit unrecorded. Reschedule
 280        # previous task so this commit is not lost.
 281        ret=$?
 282        case "$ret" in [01]) ;; *) reschedule_last_action ;; esac
 283        return $ret
 284}
 285
 286pick_one_preserving_merges () {
 287        fast_forward=t
 288        case "$1" in
 289        -n)
 290                fast_forward=f
 291                sha1=$2
 292                ;;
 293        *)
 294                sha1=$1
 295                ;;
 296        esac
 297        sha1=$(git rev-parse $sha1)
 298
 299        if test -f "$state_dir"/current-commit
 300        then
 301                if test "$fast_forward" = t
 302                then
 303                        while read current_commit
 304                        do
 305                                git rev-parse HEAD > "$rewritten"/$current_commit
 306                        done <"$state_dir"/current-commit
 307                        rm "$state_dir"/current-commit ||
 308                                die "$(gettext "Cannot write current commit's replacement sha1")"
 309                fi
 310        fi
 311
 312        echo $sha1 >> "$state_dir"/current-commit
 313
 314        # rewrite parents; if none were rewritten, we can fast-forward.
 315        new_parents=
 316        pend=" $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)"
 317        if test "$pend" = " "
 318        then
 319                pend=" root"
 320        fi
 321        while [ "$pend" != "" ]
 322        do
 323                p=$(expr "$pend" : ' \([^ ]*\)')
 324                pend="${pend# $p}"
 325
 326                if test -f "$rewritten"/$p
 327                then
 328                        new_p=$(cat "$rewritten"/$p)
 329
 330                        # If the todo reordered commits, and our parent is marked for
 331                        # rewriting, but hasn't been gotten to yet, assume the user meant to
 332                        # drop it on top of the current HEAD
 333                        if test -z "$new_p"
 334                        then
 335                                new_p=$(git rev-parse HEAD)
 336                        fi
 337
 338                        test $p != $new_p && fast_forward=f
 339                        case "$new_parents" in
 340                        *$new_p*)
 341                                ;; # do nothing; that parent is already there
 342                        *)
 343                                new_parents="$new_parents $new_p"
 344                                ;;
 345                        esac
 346                else
 347                        if test -f "$dropped"/$p
 348                        then
 349                                fast_forward=f
 350                                replacement="$(cat "$dropped"/$p)"
 351                                test -z "$replacement" && replacement=root
 352                                pend=" $replacement$pend"
 353                        else
 354                                new_parents="$new_parents $p"
 355                        fi
 356                fi
 357        done
 358        case $fast_forward in
 359        t)
 360                output warn "$(eval_gettext "Fast-forward to \$sha1")"
 361                output git reset --hard $sha1 ||
 362                        die "$(eval_gettext "Cannot fast-forward to \$sha1")"
 363                ;;
 364        f)
 365                first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
 366
 367                if [ "$1" != "-n" ]
 368                then
 369                        # detach HEAD to current parent
 370                        output git checkout $first_parent 2> /dev/null ||
 371                                die "$(eval_gettext "Cannot move HEAD to \$first_parent")"
 372                fi
 373
 374                case "$new_parents" in
 375                ' '*' '*)
 376                        test "a$1" = a-n && die "$(eval_gettext "Refusing to squash a merge: \$sha1")"
 377
 378                        # redo merge
 379                        author_script_content=$(get_author_ident_from_commit $sha1)
 380                        eval "$author_script_content"
 381                        msg_content="$(commit_message $sha1)"
 382                        # No point in merging the first parent, that's HEAD
 383                        new_parents=${new_parents# $first_parent}
 384                        merge_args="--no-log --no-ff"
 385                        if ! do_with_author output eval \
 386                        'git merge ${gpg_sign_opt:+"$gpg_sign_opt"} \
 387                                $merge_args $strategy_args -m "$msg_content" $new_parents'
 388                        then
 389                                printf "%s\n" "$msg_content" > "$GIT_DIR"/MERGE_MSG
 390                                die_with_patch $sha1 "$(eval_gettext "Error redoing merge \$sha1")"
 391                        fi
 392                        echo "$sha1 $(git rev-parse HEAD^0)" >> "$rewritten_list"
 393                        ;;
 394                *)
 395                        output eval git cherry-pick \
 396                                ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
 397                                "$strategy_args" "$@" ||
 398                                die_with_patch $sha1 "$(eval_gettext "Could not pick \$sha1")"
 399                        ;;
 400                esac
 401                ;;
 402        esac
 403}
 404
 405this_nth_commit_message () {
 406        n=$1
 407        eval_gettext "This is the commit message #\${n}:"
 408}
 409
 410skip_nth_commit_message () {
 411        n=$1
 412        eval_gettext "The commit message #\${n} will be skipped:"
 413}
 414
 415update_squash_messages () {
 416        if test -f "$squash_msg"; then
 417                mv "$squash_msg" "$squash_msg".bak || exit
 418                count=$(($(sed -n \
 419                        -e "1s/^$comment_char.*\([0-9][0-9]*\).*/\1/p" \
 420                        -e "q" < "$squash_msg".bak)+1))
 421                {
 422                        printf '%s\n' "$comment_char $(eval_ngettext \
 423                                "This is a combination of \$count commit." \
 424                                "This is a combination of \$count commits." \
 425                                $count)"
 426                        sed -e 1d -e '2,/^./{
 427                                /^$/d
 428                        }' <"$squash_msg".bak
 429                } >"$squash_msg"
 430        else
 431                commit_message HEAD > "$fixup_msg" || die "$(gettext "Cannot write \$fixup_msg")"
 432                count=2
 433                {
 434                        printf '%s\n' "$comment_char $(gettext "This is a combination of 2 commits.")"
 435                        printf '%s\n' "$comment_char $(gettext "This is the 1st commit message:")"
 436                        echo
 437                        cat "$fixup_msg"
 438                } >"$squash_msg"
 439        fi
 440        case $1 in
 441        squash)
 442                rm -f "$fixup_msg"
 443                echo
 444                printf '%s\n' "$comment_char $(this_nth_commit_message $count)"
 445                echo
 446                commit_message $2
 447                ;;
 448        fixup)
 449                echo
 450                printf '%s\n' "$comment_char $(skip_nth_commit_message $count)"
 451                echo
 452                # Change the space after the comment character to TAB:
 453                commit_message $2 | git stripspace --comment-lines | sed -e 's/ /       /'
 454                ;;
 455        esac >>"$squash_msg"
 456}
 457
 458peek_next_command () {
 459        git stripspace --strip-comments <"$todo" | sed -n -e 's/ .*//p' -e q
 460}
 461
 462# A squash/fixup has failed.  Prepare the long version of the squash
 463# commit message, then die_with_patch.  This code path requires the
 464# user to edit the combined commit message for all commits that have
 465# been squashed/fixedup so far.  So also erase the old squash
 466# messages, effectively causing the combined commit to be used as the
 467# new basis for any further squash/fixups.  Args: sha1 rest
 468die_failed_squash() {
 469        sha1=$1
 470        rest=$2
 471        mv "$squash_msg" "$msg" || exit
 472        rm -f "$fixup_msg"
 473        cp "$msg" "$GIT_DIR"/MERGE_MSG || exit
 474        warn
 475        warn "$(eval_gettext "Could not apply \$sha1... \$rest")"
 476        die_with_patch $sha1 ""
 477}
 478
 479flush_rewritten_pending() {
 480        test -s "$rewritten_pending" || return
 481        newsha1="$(git rev-parse HEAD^0)"
 482        sed "s/$/ $newsha1/" < "$rewritten_pending" >> "$rewritten_list"
 483        rm -f "$rewritten_pending"
 484}
 485
 486record_in_rewritten() {
 487        oldsha1="$(git rev-parse $1)"
 488        echo "$oldsha1" >> "$rewritten_pending"
 489
 490        case "$(peek_next_command)" in
 491        squash|s|fixup|f)
 492                ;;
 493        *)
 494                flush_rewritten_pending
 495                ;;
 496        esac
 497}
 498
 499do_pick () {
 500        sha1=$1
 501        rest=$2
 502        if test "$(git rev-parse HEAD)" = "$squash_onto"
 503        then
 504                # Set the correct commit message and author info on the
 505                # sentinel root before cherry-picking the original changes
 506                # without committing (-n).  Finally, update the sentinel again
 507                # to include these changes.  If the cherry-pick results in a
 508                # conflict, this means our behaviour is similar to a standard
 509                # failed cherry-pick during rebase, with a dirty index to
 510                # resolve before manually running git commit --amend then git
 511                # rebase --continue.
 512                git commit --allow-empty --allow-empty-message --amend \
 513                           --no-post-rewrite -n -q -C $sha1 &&
 514                        pick_one -n $sha1 &&
 515                        git commit --allow-empty --allow-empty-message \
 516                                   --amend --no-post-rewrite -n -q -C $sha1 \
 517                                   ${gpg_sign_opt:+"$gpg_sign_opt"} ||
 518                                   die_with_patch $sha1 "$(eval_gettext "Could not apply \$sha1... \$rest")"
 519        else
 520                pick_one $sha1 ||
 521                        die_with_patch $sha1 "$(eval_gettext "Could not apply \$sha1... \$rest")"
 522        fi
 523}
 524
 525do_next () {
 526        rm -f "$msg" "$author_script" "$amend" "$state_dir"/stopped-sha || exit
 527        read -r command sha1 rest < "$todo"
 528        case "$command" in
 529        "$comment_char"*|''|noop|drop|d)
 530                mark_action_done
 531                ;;
 532        "$cr")
 533                # Work around CR left by "read" (e.g. with Git for Windows' Bash).
 534                mark_action_done
 535                ;;
 536        pick|p)
 537                comment_for_reflog pick
 538
 539                mark_action_done
 540                do_pick $sha1 "$rest"
 541                record_in_rewritten $sha1
 542                ;;
 543        reword|r)
 544                comment_for_reflog reword
 545
 546                mark_action_done
 547                do_pick $sha1 "$rest"
 548                git commit --amend --no-post-rewrite ${gpg_sign_opt:+"$gpg_sign_opt"} || {
 549                        warn "$(eval_gettext "\
 550Could not amend commit after successfully picking \$sha1... \$rest
 551This is most likely due to an empty commit message, or the pre-commit hook
 552failed. If the pre-commit hook failed, you may need to resolve the issue before
 553you are able to reword the commit.")"
 554                        exit_with_patch $sha1 1
 555                }
 556                record_in_rewritten $sha1
 557                ;;
 558        edit|e)
 559                comment_for_reflog edit
 560
 561                mark_action_done
 562                do_pick $sha1 "$rest"
 563                sha1_abbrev=$(git rev-parse --short $sha1)
 564                warn "$(eval_gettext "Stopped at \$sha1_abbrev... \$rest")"
 565                exit_with_patch $sha1 0
 566                ;;
 567        squash|s|fixup|f)
 568                case "$command" in
 569                squash|s)
 570                        squash_style=squash
 571                        ;;
 572                fixup|f)
 573                        squash_style=fixup
 574                        ;;
 575                esac
 576                comment_for_reflog $squash_style
 577
 578                test -f "$done" && has_action "$done" ||
 579                        die "$(eval_gettext "Cannot '\$squash_style' without a previous commit")"
 580
 581                mark_action_done
 582                update_squash_messages $squash_style $sha1
 583                author_script_content=$(get_author_ident_from_commit HEAD)
 584                echo "$author_script_content" > "$author_script"
 585                eval "$author_script_content"
 586                if ! pick_one -n $sha1
 587                then
 588                        git rev-parse --verify HEAD >"$amend"
 589                        die_failed_squash $sha1 "$rest"
 590                fi
 591                case "$(peek_next_command)" in
 592                squash|s|fixup|f)
 593                        # This is an intermediate commit; its message will only be
 594                        # used in case of trouble.  So use the long version:
 595                        do_with_author output git commit --amend --no-verify -F "$squash_msg" \
 596                                ${gpg_sign_opt:+"$gpg_sign_opt"} ||
 597                                die_failed_squash $sha1 "$rest"
 598                        ;;
 599                *)
 600                        # This is the final command of this squash/fixup group
 601                        if test -f "$fixup_msg"
 602                        then
 603                                do_with_author git commit --amend --no-verify -F "$fixup_msg" \
 604                                        ${gpg_sign_opt:+"$gpg_sign_opt"} ||
 605                                        die_failed_squash $sha1 "$rest"
 606                        else
 607                                cp "$squash_msg" "$GIT_DIR"/SQUASH_MSG || exit
 608                                rm -f "$GIT_DIR"/MERGE_MSG
 609                                do_with_author git commit --amend --no-verify -F "$GIT_DIR"/SQUASH_MSG -e \
 610                                        ${gpg_sign_opt:+"$gpg_sign_opt"} ||
 611                                        die_failed_squash $sha1 "$rest"
 612                        fi
 613                        rm -f "$squash_msg" "$fixup_msg"
 614                        ;;
 615                esac
 616                record_in_rewritten $sha1
 617                ;;
 618        x|"exec")
 619                read -r command rest < "$todo"
 620                mark_action_done
 621                eval_gettextln "Executing: \$rest"
 622                "${SHELL:-@SHELL_PATH@}" -c "$rest" # Actual execution
 623                status=$?
 624                # Run in subshell because require_clean_work_tree can die.
 625                dirty=f
 626                (require_clean_work_tree "rebase" 2>/dev/null) || dirty=t
 627                if test "$status" -ne 0
 628                then
 629                        warn "$(eval_gettext "Execution failed: \$rest")"
 630                        test "$dirty" = f ||
 631                                warn "$(gettext "and made changes to the index and/or the working tree")"
 632
 633                        warn "$(gettext "\
 634You can fix the problem, and then run
 635
 636        git rebase --continue")"
 637                        warn
 638                        if test $status -eq 127         # command not found
 639                        then
 640                                status=1
 641                        fi
 642                        exit "$status"
 643                elif test "$dirty" = t
 644                then
 645                        # TRANSLATORS: after these lines is a command to be issued by the user
 646                        warn "$(eval_gettext "\
 647Execution succeeded: \$rest
 648but left changes to the index and/or the working tree
 649Commit or stash your changes, and then run
 650
 651        git rebase --continue")"
 652                        warn
 653                        exit 1
 654                fi
 655                ;;
 656        *)
 657                warn "$(eval_gettext "Unknown command: \$command \$sha1 \$rest")"
 658                fixtodo="$(gettext "Please fix this using 'git rebase --edit-todo'.")"
 659                if git rev-parse --verify -q "$sha1" >/dev/null
 660                then
 661                        die_with_patch $sha1 "$fixtodo"
 662                else
 663                        die "$fixtodo"
 664                fi
 665                ;;
 666        esac
 667        test -s "$todo" && return
 668
 669        comment_for_reflog finish &&
 670        newhead=$(git rev-parse HEAD) &&
 671        case $head_name in
 672        refs/*)
 673                message="$GIT_REFLOG_ACTION: $head_name onto $onto" &&
 674                git update-ref -m "$message" $head_name $newhead $orig_head &&
 675                git symbolic-ref \
 676                  -m "$GIT_REFLOG_ACTION: returning to $head_name" \
 677                  HEAD $head_name
 678                ;;
 679        esac && {
 680                test ! -f "$state_dir"/verbose ||
 681                        git diff-tree --stat $orig_head..HEAD
 682        } &&
 683        {
 684                test -s "$rewritten_list" &&
 685                git notes copy --for-rewrite=rebase < "$rewritten_list" ||
 686                true # we don't care if this copying failed
 687        } &&
 688        hook="$(git rev-parse --git-path hooks/post-rewrite)"
 689        if test -x "$hook" && test -s "$rewritten_list"; then
 690                "$hook" rebase < "$rewritten_list"
 691                true # we don't care if this hook failed
 692        fi &&
 693                warn "$(eval_gettext "Successfully rebased and updated \$head_name.")"
 694
 695        return 1 # not failure; just to break the do_rest loop
 696}
 697
 698# can only return 0, when the infinite loop breaks
 699do_rest () {
 700        while :
 701        do
 702                do_next || break
 703        done
 704}
 705
 706# skip picking commits whose parents are unchanged
 707skip_unnecessary_picks () {
 708        fd=3
 709        while read -r command rest
 710        do
 711                # fd=3 means we skip the command
 712                case "$fd,$command" in
 713                3,pick|3,p)
 714                        # pick a commit whose parent is current $onto -> skip
 715                        sha1=${rest%% *}
 716                        case "$(git rev-parse --verify --quiet "$sha1"^)" in
 717                        "$onto"*)
 718                                onto=$sha1
 719                                ;;
 720                        *)
 721                                fd=1
 722                                ;;
 723                        esac
 724                        ;;
 725                3,"$comment_char"*|3,)
 726                        # copy comments
 727                        ;;
 728                *)
 729                        fd=1
 730                        ;;
 731                esac
 732                printf '%s\n' "$command${rest:+ }$rest" >&$fd
 733        done <"$todo" >"$todo.new" 3>>"$done" &&
 734        mv -f "$todo".new "$todo" &&
 735        case "$(peek_next_command)" in
 736        squash|s|fixup|f)
 737                record_in_rewritten "$onto"
 738                ;;
 739        esac ||
 740                die "$(gettext "Could not skip unnecessary pick commands")"
 741}
 742
 743transform_todo_ids () {
 744        while read -r command rest
 745        do
 746                case "$command" in
 747                "$comment_char"* | exec)
 748                        # Be careful for oddball commands like 'exec'
 749                        # that do not have a SHA-1 at the beginning of $rest.
 750                        ;;
 751                *)
 752                        sha1=$(git rev-parse --verify --quiet "$@" ${rest%%[     ]*}) &&
 753                        rest="$sha1 ${rest#*[    ]}"
 754                        ;;
 755                esac
 756                printf '%s\n' "$command${rest:+ }$rest"
 757        done <"$todo" >"$todo.new" &&
 758        mv -f "$todo.new" "$todo"
 759}
 760
 761expand_todo_ids() {
 762        transform_todo_ids
 763}
 764
 765collapse_todo_ids() {
 766        transform_todo_ids --short
 767}
 768
 769# Rearrange the todo list that has both "pick sha1 msg" and
 770# "pick sha1 fixup!/squash! msg" appears in it so that the latter
 771# comes immediately after the former, and change "pick" to
 772# "fixup"/"squash".
 773#
 774# Note that if the config has specified a custom instruction format
 775# each log message will be re-retrieved in order to normalize the
 776# autosquash arrangement
 777rearrange_squash () {
 778        # extract fixup!/squash! lines and resolve any referenced sha1's
 779        while read -r pick sha1 message
 780        do
 781                test -z "${format}" || message=$(git log -n 1 --format="%s" ${sha1})
 782                case "$message" in
 783                "squash! "*|"fixup! "*)
 784                        action="${message%%!*}"
 785                        rest=$message
 786                        prefix=
 787                        # skip all squash! or fixup! (but save for later)
 788                        while :
 789                        do
 790                                case "$rest" in
 791                                "squash! "*|"fixup! "*)
 792                                        prefix="$prefix${rest%%!*},"
 793                                        rest="${rest#*! }"
 794                                        ;;
 795                                *)
 796                                        break
 797                                        ;;
 798                                esac
 799                        done
 800                        printf '%s %s %s %s\n' "$sha1" "$action" "$prefix" "$rest"
 801                        # if it's a single word, try to resolve to a full sha1 and
 802                        # emit a second copy. This allows us to match on both message
 803                        # and on sha1 prefix
 804                        if test "${rest#* }" = "$rest"; then
 805                                fullsha="$(git rev-parse -q --verify "$rest" 2>/dev/null)"
 806                                if test -n "$fullsha"; then
 807                                        # prefix the action to uniquely identify this line as
 808                                        # intended for full sha1 match
 809                                        echo "$sha1 +$action $prefix $fullsha"
 810                                fi
 811                        fi
 812                esac
 813        done >"$1.sq" <"$1"
 814        test -s "$1.sq" || return
 815
 816        used=
 817        while read -r pick sha1 message
 818        do
 819                case " $used" in
 820                *" $sha1 "*) continue ;;
 821                esac
 822                printf '%s\n' "$pick $sha1 $message"
 823                test -z "${format}" || message=$(git log -n 1 --format="%s" ${sha1})
 824                used="$used$sha1 "
 825                while read -r squash action msg_prefix msg_content
 826                do
 827                        case " $used" in
 828                        *" $squash "*) continue ;;
 829                        esac
 830                        emit=0
 831                        case "$action" in
 832                        +*)
 833                                action="${action#+}"
 834                                # full sha1 prefix test
 835                                case "$msg_content" in "$sha1"*) emit=1;; esac ;;
 836                        *)
 837                                # message prefix test
 838                                case "$message" in "$msg_content"*) emit=1;; esac ;;
 839                        esac
 840                        if test $emit = 1; then
 841                                if test -n "${format}"
 842                                then
 843                                        msg_content=$(git log -n 1 --format="${format}" ${squash})
 844                                else
 845                                        msg_content="$(echo "$msg_prefix" | sed "s/,/! /g")$msg_content"
 846                                fi
 847                                printf '%s\n' "$action $squash $msg_content"
 848                                used="$used$squash "
 849                        fi
 850                done <"$1.sq"
 851        done >"$1.rearranged" <"$1"
 852        cat "$1.rearranged" >"$1"
 853        rm -f "$1.sq" "$1.rearranged"
 854}
 855
 856# Add commands after a pick or after a squash/fixup serie
 857# in the todo list.
 858add_exec_commands () {
 859        {
 860                first=t
 861                while read -r insn rest
 862                do
 863                        case $insn in
 864                        pick)
 865                                test -n "$first" ||
 866                                printf "%s" "$cmd"
 867                                ;;
 868                        esac
 869                        printf "%s %s\n" "$insn" "$rest"
 870                        first=
 871                done
 872                printf "%s" "$cmd"
 873        } <"$1" >"$1.new" &&
 874        mv "$1.new" "$1"
 875}
 876
 877# Check if the SHA-1 passed as an argument is a
 878# correct one, if not then print $2 in "$todo".badsha
 879# $1: the SHA-1 to test
 880# $2: the line number of the input
 881# $3: the input filename
 882check_commit_sha () {
 883        badsha=0
 884        if test -z "$1"
 885        then
 886                badsha=1
 887        else
 888                sha1_verif="$(git rev-parse --verify --quiet $1^{commit})"
 889                if test -z "$sha1_verif"
 890                then
 891                        badsha=1
 892                fi
 893        fi
 894
 895        if test $badsha -ne 0
 896        then
 897                line="$(sed -n -e "${2}p" "$3")"
 898                warn "$(eval_gettext "\
 899Warning: the SHA-1 is missing or isn't a commit in the following line:
 900 - \$line")"
 901                warn
 902        fi
 903
 904        return $badsha
 905}
 906
 907# prints the bad commits and bad commands
 908# from the todolist in stdin
 909check_bad_cmd_and_sha () {
 910        retval=0
 911        lineno=0
 912        while read -r command rest
 913        do
 914                lineno=$(( $lineno + 1 ))
 915                case $command in
 916                "$comment_char"*|''|noop|x|exec)
 917                        # Doesn't expect a SHA-1
 918                        ;;
 919                "$cr")
 920                        # Work around CR left by "read" (e.g. with Git for
 921                        # Windows' Bash).
 922                        ;;
 923                pick|p|drop|d|reword|r|edit|e|squash|s|fixup|f)
 924                        if ! check_commit_sha "${rest%%[        ]*}" "$lineno" "$1"
 925                        then
 926                                retval=1
 927                        fi
 928                        ;;
 929                *)
 930                        line="$(sed -n -e "${lineno}p" "$1")"
 931                        warn "$(eval_gettext "\
 932Warning: the command isn't recognized in the following line:
 933 - \$line")"
 934                        warn
 935                        retval=1
 936                        ;;
 937                esac
 938        done <"$1"
 939        return $retval
 940}
 941
 942# Print the list of the SHA-1 of the commits
 943# from stdin to stdout
 944todo_list_to_sha_list () {
 945        git stripspace --strip-comments |
 946        while read -r command sha1 rest
 947        do
 948                case $command in
 949                "$comment_char"*|''|noop|x|"exec")
 950                        ;;
 951                *)
 952                        long_sha=$(git rev-list --no-walk "$sha1" 2>/dev/null)
 953                        printf "%s\n" "$long_sha"
 954                        ;;
 955                esac
 956        done
 957}
 958
 959# Use warn for each line in stdin
 960warn_lines () {
 961        while read -r line
 962        do
 963                warn " - $line"
 964        done
 965}
 966
 967# Switch to the branch in $into and notify it in the reflog
 968checkout_onto () {
 969        GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $onto_name"
 970        output git checkout $onto || die_abort "$(gettext "could not detach HEAD")"
 971        git update-ref ORIG_HEAD $orig_head
 972}
 973
 974get_missing_commit_check_level () {
 975        check_level=$(git config --get rebase.missingCommitsCheck)
 976        check_level=${check_level:-ignore}
 977        # Don't be case sensitive
 978        printf '%s' "$check_level" | tr 'A-Z' 'a-z'
 979}
 980
 981# Check if the user dropped some commits by mistake
 982# Behaviour determined by rebase.missingCommitsCheck.
 983# Check if there is an unrecognized command or a
 984# bad SHA-1 in a command.
 985check_todo_list () {
 986        raise_error=f
 987
 988        check_level=$(get_missing_commit_check_level)
 989
 990        case "$check_level" in
 991        warn|error)
 992                # Get the SHA-1 of the commits
 993                todo_list_to_sha_list <"$todo".backup >"$todo".oldsha1
 994                todo_list_to_sha_list <"$todo" >"$todo".newsha1
 995
 996                # Sort the SHA-1 and compare them
 997                sort -u "$todo".oldsha1 >"$todo".oldsha1+
 998                mv "$todo".oldsha1+ "$todo".oldsha1
 999                sort -u "$todo".newsha1 >"$todo".newsha1+
1000                mv "$todo".newsha1+ "$todo".newsha1
1001                comm -2 -3 "$todo".oldsha1 "$todo".newsha1 >"$todo".miss
1002
1003                # Warn about missing commits
1004                if test -s "$todo".miss
1005                then
1006                        test "$check_level" = error && raise_error=t
1007
1008                        warn "$(gettext "\
1009Warning: some commits may have been dropped accidentally.
1010Dropped commits (newer to older):")"
1011
1012                        # Make the list user-friendly and display
1013                        opt="--no-walk=sorted --format=oneline --abbrev-commit --stdin"
1014                        git rev-list $opt <"$todo".miss | warn_lines
1015
1016                        warn "$(gettext "\
1017To avoid this message, use \"drop\" to explicitly remove a commit.
1018
1019Use 'git config rebase.missingCommitsCheck' to change the level of warnings.
1020The possible behaviours are: ignore, warn, error.")"
1021                        warn
1022                fi
1023                ;;
1024        ignore)
1025                ;;
1026        *)
1027                warn "$(eval_gettext "Unrecognized setting \$check_level for option rebase.missingCommitsCheck. Ignoring.")"
1028                ;;
1029        esac
1030
1031        if ! check_bad_cmd_and_sha "$todo"
1032        then
1033                raise_error=t
1034        fi
1035
1036        if test $raise_error = t
1037        then
1038                # Checkout before the first commit of the
1039                # rebase: this way git rebase --continue
1040                # will work correctly as it expects HEAD to be
1041                # placed before the commit of the next action
1042                checkout_onto
1043
1044                warn "$(gettext "You can fix this with 'git rebase --edit-todo' and then run 'git rebase --continue'.")"
1045                die "$(gettext "Or you can abort the rebase with 'git rebase --abort'.")"
1046        fi
1047}
1048
1049# The whole contents of this file is run by dot-sourcing it from
1050# inside a shell function.  It used to be that "return"s we see
1051# below were not inside any function, and expected to return
1052# to the function that dot-sourced us.
1053#
1054# However, older (9.x) versions of FreeBSD /bin/sh misbehave on such a
1055# construct and continue to run the statements that follow such a "return".
1056# As a work-around, we introduce an extra layer of a function
1057# here, and immediately call it after defining it.
1058git_rebase__interactive () {
1059
1060case "$action" in
1061continue)
1062        # do we have anything to commit?
1063        if git diff-index --cached --quiet HEAD --
1064        then
1065                # Nothing to commit -- skip this commit
1066
1067                test ! -f "$GIT_DIR"/CHERRY_PICK_HEAD ||
1068                rm "$GIT_DIR"/CHERRY_PICK_HEAD ||
1069                die "$(gettext "Could not remove CHERRY_PICK_HEAD")"
1070        else
1071                if ! test -f "$author_script"
1072                then
1073                        gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
1074                        die "$(eval_gettext "\
1075You have staged changes in your working tree.
1076If these changes are meant to be
1077squashed into the previous commit, run:
1078
1079  git commit --amend \$gpg_sign_opt_quoted
1080
1081If they are meant to go into a new commit, run:
1082
1083  git commit \$gpg_sign_opt_quoted
1084
1085In both cases, once you're done, continue with:
1086
1087  git rebase --continue
1088")"
1089                fi
1090                . "$author_script" ||
1091                        die "$(gettext "Error trying to find the author identity to amend commit")"
1092                if test -f "$amend"
1093                then
1094                        current_head=$(git rev-parse --verify HEAD)
1095                        test "$current_head" = $(cat "$amend") ||
1096                        die "$(gettext "\
1097You have uncommitted changes in your working tree. Please commit them
1098first and then run 'git rebase --continue' again.")"
1099                        do_with_author git commit --amend --no-verify -F "$msg" -e \
1100                                ${gpg_sign_opt:+"$gpg_sign_opt"} ||
1101                                die "$(gettext "Could not commit staged changes.")"
1102                else
1103                        do_with_author git commit --no-verify -F "$msg" -e \
1104                                ${gpg_sign_opt:+"$gpg_sign_opt"} ||
1105                                die "$(gettext "Could not commit staged changes.")"
1106                fi
1107        fi
1108
1109        if test -r "$state_dir"/stopped-sha
1110        then
1111                record_in_rewritten "$(cat "$state_dir"/stopped-sha)"
1112        fi
1113
1114        require_clean_work_tree "rebase"
1115        do_rest
1116        return 0
1117        ;;
1118skip)
1119        git rerere clear
1120
1121        do_rest
1122        return 0
1123        ;;
1124edit-todo)
1125        git stripspace --strip-comments <"$todo" >"$todo".new
1126        mv -f "$todo".new "$todo"
1127        collapse_todo_ids
1128        append_todo_help
1129        gettext "
1130You are editing the todo file of an ongoing interactive rebase.
1131To continue rebase after editing, run:
1132    git rebase --continue
1133
1134" | git stripspace --comment-lines >>"$todo"
1135
1136        git_sequence_editor "$todo" ||
1137                die "$(gettext "Could not execute editor")"
1138        expand_todo_ids
1139
1140        exit
1141        ;;
1142esac
1143
1144comment_for_reflog start
1145
1146if test ! -z "$switch_to"
1147then
1148        GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $switch_to"
1149        output git checkout "$switch_to" -- ||
1150                die "$(eval_gettext "Could not checkout \$switch_to")"
1151
1152        comment_for_reflog start
1153fi
1154
1155orig_head=$(git rev-parse --verify HEAD) || die "$(gettext "No HEAD?")"
1156mkdir -p "$state_dir" || die "$(eval_gettext "Could not create temporary \$state_dir")"
1157
1158: > "$state_dir"/interactive || die "$(gettext "Could not mark as interactive")"
1159write_basic_state
1160if test t = "$preserve_merges"
1161then
1162        if test -z "$rebase_root"
1163        then
1164                mkdir "$rewritten" &&
1165                for c in $(git merge-base --all $orig_head $upstream)
1166                do
1167                        echo $onto > "$rewritten"/$c ||
1168                                die "$(gettext "Could not init rewritten commits")"
1169                done
1170        else
1171                mkdir "$rewritten" &&
1172                echo $onto > "$rewritten"/root ||
1173                        die "$(gettext "Could not init rewritten commits")"
1174        fi
1175        # No cherry-pick because our first pass is to determine
1176        # parents to rewrite and skipping dropped commits would
1177        # prematurely end our probe
1178        merges_option=
1179else
1180        merges_option="--no-merges --cherry-pick"
1181fi
1182
1183shorthead=$(git rev-parse --short $orig_head)
1184shortonto=$(git rev-parse --short $onto)
1185if test -z "$rebase_root"
1186        # this is now equivalent to ! -z "$upstream"
1187then
1188        shortupstream=$(git rev-parse --short $upstream)
1189        revisions=$upstream...$orig_head
1190        shortrevisions=$shortupstream..$shorthead
1191else
1192        revisions=$onto...$orig_head
1193        shortrevisions=$shorthead
1194fi
1195format=$(git config --get rebase.instructionFormat)
1196# the 'rev-list .. | sed' requires %m to parse; the instruction requires %H to parse
1197git rev-list $merges_option --format="%m%H ${format:-%s}" \
1198        --reverse --left-right --topo-order \
1199        $revisions ${restrict_revision+^$restrict_revision} | \
1200        sed -n "s/^>//p" |
1201while read -r sha1 rest
1202do
1203
1204        if test -z "$keep_empty" && is_empty_commit $sha1 && ! is_merge_commit $sha1
1205        then
1206                comment_out="$comment_char "
1207        else
1208                comment_out=
1209        fi
1210
1211        if test t != "$preserve_merges"
1212        then
1213                printf '%s\n' "${comment_out}pick $sha1 $rest" >>"$todo"
1214        else
1215                if test -z "$rebase_root"
1216                then
1217                        preserve=t
1218                        for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)
1219                        do
1220                                if test -f "$rewritten"/$p
1221                                then
1222                                        preserve=f
1223                                fi
1224                        done
1225                else
1226                        preserve=f
1227                fi
1228                if test f = "$preserve"
1229                then
1230                        touch "$rewritten"/$sha1
1231                        printf '%s\n' "${comment_out}pick $sha1 $rest" >>"$todo"
1232                fi
1233        fi
1234done
1235
1236# Watch for commits that been dropped by --cherry-pick
1237if test t = "$preserve_merges"
1238then
1239        mkdir "$dropped"
1240        # Save all non-cherry-picked changes
1241        git rev-list $revisions --left-right --cherry-pick | \
1242                sed -n "s/^>//p" > "$state_dir"/not-cherry-picks
1243        # Now all commits and note which ones are missing in
1244        # not-cherry-picks and hence being dropped
1245        git rev-list $revisions |
1246        while read rev
1247        do
1248                if test -f "$rewritten"/$rev &&
1249                   ! sane_grep "$rev" "$state_dir"/not-cherry-picks >/dev/null
1250                then
1251                        # Use -f2 because if rev-list is telling us this commit is
1252                        # not worthwhile, we don't want to track its multiple heads,
1253                        # just the history of its first-parent for others that will
1254                        # be rebasing on top of it
1255                        git rev-list --parents -1 $rev | cut -d' ' -s -f2 > "$dropped"/$rev
1256                        sha1=$(git rev-list -1 $rev)
1257                        sane_grep -v "^[a-z][a-z]* $sha1" <"$todo" > "${todo}2" ; mv "${todo}2" "$todo"
1258                        rm "$rewritten"/$rev
1259                fi
1260        done
1261fi
1262
1263test -s "$todo" || echo noop >> "$todo"
1264test -n "$autosquash" && rearrange_squash "$todo"
1265test -n "$cmd" && add_exec_commands "$todo"
1266
1267todocount=$(git stripspace --strip-comments <"$todo" | wc -l)
1268todocount=${todocount##* }
1269
1270cat >>"$todo" <<EOF
1271
1272$comment_char $(eval_ngettext \
1273        "Rebase \$shortrevisions onto \$shortonto (\$todocount command)" \
1274        "Rebase \$shortrevisions onto \$shortonto (\$todocount commands)" \
1275        "$todocount")
1276EOF
1277append_todo_help
1278gettext "
1279However, if you remove everything, the rebase will be aborted.
1280
1281" | git stripspace --comment-lines >>"$todo"
1282
1283if test -z "$keep_empty"
1284then
1285        printf '%s\n' "$comment_char $(gettext "Note that empty commits are commented out")" >>"$todo"
1286fi
1287
1288
1289has_action "$todo" ||
1290        return 2
1291
1292cp "$todo" "$todo".backup
1293collapse_todo_ids
1294git_sequence_editor "$todo" ||
1295        die_abort "$(gettext "Could not execute editor")"
1296
1297has_action "$todo" ||
1298        return 2
1299
1300check_todo_list
1301
1302expand_todo_ids
1303
1304test -d "$rewritten" || test -n "$force_rebase" || skip_unnecessary_picks
1305
1306checkout_onto
1307do_rest
1308
1309}
1310# ... and then we call the whole thing.
1311git_rebase__interactive